#!/usr/bin/perl -w

# Copyright (c) 2001 imacat
# vҦ (c) 2001 ̺
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# {OۥѳnAziHӦۥѳn|] Free Software Foundation
# ^X GNU qΤ@\iұڡ] GNU General Public License ^ĤG
# ӭקMsoGo@{AΪ̦ۥѿܨϥΥsC
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# oGo@{تOƱ楦ΡASOCƦܨSAXSwت
# tOCԲӪpаѾ\ GNU qΤ@\iҡC
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# zӤwgM{@_@ GNU qΤ@\iҪƥCpG٨SAg
# HG Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# ɮצW:	arclog.pl
# ɮ׻:	Perl Oɫkɵ{
# ɮת:	2.1.0
# ɮק@:	̺ <imacat@mail.imacat.idv.tw>
# Z:	2001-01-05
# vr:	(c) 2001 ̺

# Filename:	arclog.pl
# Description:	Perl script to archieve log files monthly
# Version:	2.1.0
# Author:	imacat <imacat@mail.imacat.idv.tw>
# Date:		2001-01-05
# Copyright:	(c) 2001 imacat

use 5.005;
use strict;
use Fcntl qw(:flock);
use IO::File qw();
use IO::Handle qw(autoflush);
use Getopt::Long qw(GetOptions);
use Cwd qw(cwd);
use File::Basename qw(basename fileparse);
use File::Spec::Functions qw(file_name_is_absolute catfile splitdir curdir updir);
use File::Temp qw(tempfile);
use Config qw(%Config);
use Date::Parse qw(str2time);

use vars qw($VERBOSE $COMPRESS_SUFFIX $TMP_SUFFIX $SORT $SORT_SIZE_LIMIT $THIS_MONTH $DATE_RE %FN);
$VERBOSE = 1;
*TMP_SUFFIX = \".tmp-arclog";
$SORT = 0;
*SORT_SIZE_LIMIT = \50000000;
$THIS_MONTH = to_yyyymm($^T);
%FN = qw();
use vars qw($OVERRIDE $DEFAULT_OVERRIDE_TTY $DEFAULT_OVERRIDE_NOTTY $KEEP $DEFAULT_KEEP);
*DEFAULT_OVERRIDE_TTY = \"ask";
*DEFAULT_OVERRIDE_NOTTY = \"fail";
*DEFAULT_KEEP = \"this-month";
use vars qw($COMPRESS $DEFAULT_COMPRESS $GZIP $GZIP_SUFFIX $BZIP2 $BZIP2_SUFFIX);
*DEFAULT_COMPRESS = \"gzip";
*GZIP_SUFFIX = \".gz";
*BZIP2_SUFFIX = \".bz2";
use vars qw(%FILE_TYPES);
# STDIN is always assumed to text/plain STDIN @߷ text/plain
$FILE_TYPES{"-"} = "text/plain";
use vars qw($WORKING_SRC);

use vars qw($THIS_FILE $SHORTHELP $VERSION $VERSTR $HELPSTR);
$0 =~ /[^\/]*$/;
$THIS_FILE = $&;
$SHORTHELP = "Try `$THIS_FILE --help' for more information.";
*VERSION = \"2.1.0";
$VERSTR = "$& v$VERSION by imacat <imacat\@mail.imacat.idv.tw>";
$HELPSTR = << "EOF";
Usage: $THIS_FILE [options] logfile... [output]
Archieve the log files monthly.

  logfile            The log file to be archieved.
  output             The prefix of the output files.  The output files will be
                     named as pre.yyyymm, ie: pre.200001, pre.200002.  If not
                     specified, the default prefix is the logfile pathname.
  --compress[=mode]  Compress the archived files.   Available modes are: gzip,
                     bzip2 and none.  The default is gzip.
  --sort             Sort the records in the log files by time.
  --nosort           Don't sort the records. (default)
  --override[=mode]  The override behavior when the target archived files
                     exist.  Available modes are: overwrite, append, ignore,
                     fail and ask.  If not specified, the default is "ask" on
                     tty, "fail" for else.  If specified without mode, the
                     default is "overwrite".
  --keep[=mode]      What to keep in the logfile.  Available modes are: all,
                     restart, delete and this-month.  If not specified, the
                     default is "this-month".  If specified without mode, the
                     default is "all".
  -d,--debug         Display debugging messages.
  -q,--quiet         Be quiet.  Only yell when errors.
  -h,--help          Display this help.
  -v,--version       Display version number.

EOF

main();
exit 0;

# main: Main program D{
sub main {
    local $_;
    my (@sources, $output);
    my ($total, $val_counter);
    
    # Parse the arguments ѼƸѪR
    ($output, @sources) = parse_args();
    
    # Archive each log file @Ӥ@kɾz
    ($total, $val_counter) = (0, 0);
    foreach (@sources) {
        # Archive a log file z@ӰO
        @_ = arc_log ($_, $FILE_TYPES{$_}, $output);
        $total += $_[0];
        $val_counter += $_[1];
    }
    
    # Delete the temporary working files RȦs
    foreach (sort keys %FN) {
        print STDERR "Deleting temporary file for $_... " if $VERBOSE >= 2;
        unlink $FN{$_} or die "$THIS_FILE: $!";
        print STDERR "done\n" if $VERBOSE >= 2;
    }
    
    # Print the statistics ܲέpG
    print STDERR "" . format_number(0+keys %FN) . " archieve files written, " . format_number(time - $^T) . " seconds elapsed.\n" if $VERBOSE >= 1;
    return;
}

# parse_args: Parse the arguments ѼƸѪR
sub parse_args {
    local $_;
    my (@sources, %sources, $output);
    
    # Get the arguments oѼ
    eval {
        local $SIG{__WARN__} = sub { die $_[0]; };
        Getopt::Long::Configure ("no_auto_abbrev");
        GetOptions( "compress|c:s"=>\$COMPRESS,
                    "nocompress"=>sub { $COMPRESS = "none"; },
                    "sort|s!"=>\$SORT,
                    "override|o:s"=>\$OVERRIDE,
                    "keep|k:s"=>\$KEEP,
                    "debug|d"=>sub { $VERBOSE = 2; },
                    "quiet|q"=>sub { $VERBOSE = 0; },
                    "help|h"=>sub { print $HELPSTR; exit 0; },
                    "version|v"=>sub { print "$VERSTR\n"; exit 0; });
    };
    $! = 1;
    die "$THIS_FILE: $@" if $@;
    if (defined $OVERRIDE) {
        $OVERRIDE = "overwrite" if $OVERRIDE eq "";
        $OVERRIDE = lc $OVERRIDE;
        if ($OVERRIDE eq "o") {
            $OVERRIDE = "overwrite";
        } elsif ($OVERRIDE eq "a") {
            $OVERRIDE = "append";
        } elsif ($OVERRIDE eq "i") {
            $OVERRIDE = "ignore";
        } elsif ($OVERRIDE eq "f") {
            $OVERRIDE = "fail";
        }
        die "$THIS_FILE: Unknown override mode: $OVERRIDE"
            unless grep $_ eq $OVERRIDE, qw(overwrite append ignore fail ask);
    }
    if (defined $KEEP) {
        $KEEP = "all" if $KEEP eq "";
        $KEEP = lc $KEEP;
        if ($KEEP eq "a") {
            $KEEP = "all";
        } elsif ($KEEP eq "r") {
            $KEEP = "restart";
        } elsif ($KEEP eq "d") {
            $KEEP = "delete";
        } elsif ($KEEP eq "t") {
            $KEEP = "this-month";
        }
        die "$THIS_FILE: Unknown keep mode: $KEEP"
            unless grep $_ eq $KEEP, qw(all restart delete this-month);
    }
    if (defined $COMPRESS) {
        $COMPRESS = "gzip" if $COMPRESS eq "";
        $COMPRESS = lc $COMPRESS;
        if ($COMPRESS eq "g") {
            $COMPRESS = "gzip";
        } elsif ($COMPRESS eq "b") {
            $COMPRESS = "bzip2";
        } elsif ($COMPRESS eq "n") {
            $COMPRESS = "none";
        }
        die "$THIS_FILE: Unknown compress mode: $COMPRESS"
            unless grep $_ eq $COMPRESS, qw(gzip bzip2 none);
    }
    
    # Get the rest arguments olѼ
    @sources = qw();
    # No arguments SѼ
    if (@ARGV == 0) {
    # Only one argument -- source the same with the output prefix @ӰѼơСпJMX}YۦP
    } elsif (@ARGV == 1) {
        @sources = ($ARGV[0]);
        $output = $ARGV[0] if $ARGV[0] ne "-";
        $output =~ s/\.(?:gz|bz2)$//;
    # Many arguments -- last one is the output prefix ܦhӰѼơСг̫@ӬOX}Y
    } else {
        $output = pop @ARGV;
        @sources = @ARGV;
    }
    
    # Set the verbose level ]wT
    autoflush STDOUT if $VERBOSE >= 2;
    
    # Check the log file ˬdO
    $! = 1;
    die "$THIS_FILE: Which log file do you want to archive?\n$SHORTHELP\n"
        unless @sources > 0;
    die "$THIS_FILE: You can only specify STDIN once\n$SHORTHELP\n"
        if grep ($_ eq "-", @sources) > 1;
    foreach (@sources) {
        # No need to check STDIN ˬdзǿJ
        next if $_ eq "-";
        $_ = rel2abs($_);
        die "$THIS_FILE: No such file or directory: $_\n$SHORTHELP\n"
            unless -e $_;
        die "$THIS_FILE: Permission denied: $_\n$SHORTHELP\n"
            unless -r $_ && -w $_;
        # Check the file format ˬdɮ׮榡
        $FILE_TYPES{$_} = check_file_type($_);
        # Check the needed compress method ˬdһݪYk
        if ($FILE_TYPES{$_} =~ /gzip/i) {
            check_gzip();
            $FILE_TYPES{$_} = "application/x-gzip";
        } elsif ($FILE_TYPES{$_} =~ /bzip2/i) {
            check_bzip2();
            $FILE_TYPES{$_} = "application/x-bzip2";
        } elsif ($FILE_TYPES{$_} =~ /text/i || $FILE_TYPES{$_} =~ /empty/i) {
            $FILE_TYPES{$_} = "text/plain";
        # Not available 
        } else {
            die "$THIS_FILE: Unsupported file format: $FILE_TYPES{$_} ($_)\n$SHORTHELP\n";
        }
    }
    
    # Can't get the log file and the answer both from STDIN OɩMݵҦPɨӦۼзǿJ
    if (defined $OVERRIDE) {
        if (grep ($_ eq "-", @sources) > 0 && $OVERRIDE eq "ask") {
            print STDERR "$THIS_FILE: Can't read from STDIN in ask mode.  Change to fail mode.\n";
            $OVERRIDE = "fail";
        }
    }
    
    # Set the default override mode ]ww]\ɼҦ
    if (!defined $OVERRIDE) {
        if (-t STDIN) {
            $OVERRIDE = $DEFAULT_OVERRIDE_TTY;
        } else {
            $OVERRIDE = $DEFAULT_OVERRIDE_NOTTY;
        }
    }
    # Set the default keep mode ]ww]OdҦ
    if (!defined $KEEP) {
        $KEEP = $DEFAULT_KEEP;
    }
    # Set the default compress mode ]ww]YҦ
    if (!defined $COMPRESS) {
        $COMPRESS = $DEFAULT_COMPRESS;
    }
    
    # Can't keep the records of this month back in STDIN Os^зǿJ
    if (grep ($_ eq "-", @sources) > 0 && $KEEP eq "this-month") {
        print STDERR "$THIS_FILE: Can't keep this-month in STDIN.  Change to keep all.\n";
        $KEEP = "all";
    }
    # Can't delete STDIN зǿJLkR
    if (grep ($_ eq "-", @sources) > 0 && $KEEP eq "delete") {
        print STDERR "$THIS_FILE: Can't delete the STDIN.  Change to keep all.\n";
        $KEEP = "all";
    }
    # Can't restart STDIN зǿJLkks
    if (grep ($_ eq "-", @sources) > 0 && $KEEP eq "restart") {
        print STDERR "$THIS_FILE: Can't restart the STDIN.  Change to keep all.\n";
        $KEEP = "all";
    }
    
    # Check the needed compress method ˬdһݪYk
    if ($COMPRESS eq "gzip") {
        check_gzip();
        $COMPRESS_SUFFIX = $GZIP_SUFFIX;
    } elsif ($COMPRESS eq "bzip2") {
        check_bzip2();
        $COMPRESS_SUFFIX = $BZIP2_SUFFIX;
    }
    
    # Check the output file prefix ˬdXɮ
    $! = 1;
    die "$THIS_FILE: Please specify output prefix\n$SHORTHELP\n"
        unless defined $output;
    die "$THIS_FILE: You can't specify STDOUT as the output prefix\n$SHORTHELP\n"
        if $output eq "-";
    $output = rel2abs ($output);
    $_ = (fileparse $output)[1];
    $! = 1;
    die "$THIS_FILE: No such file or directory: $_\n$SHORTHELP\n"
        unless -e $_;
    die "$THIS_FILE: Invalid directory: $_\n$SHORTHELP\n"
        unless -d $_;
    die "$THIS_FILE: Permission denied: $_\n$SHORTHELP\n"
        unless -w $_;
    die "$THIS_FILE: Temporary file found: $output$TMP_SUFFIX\n$SHORTHELP\n"
        if -e "$output$TMP_SUFFIX";
    
    return ($output, @sources);
}

# arc_log: Archive a log file z@ӰO
sub arc_log {
    local $_;
    my ($source, $type, $output, $working);
    my ($total, $val_counter);
    my ($month, $cur_month, $fh);
    my ($entry);
    my (%mon_counter);
    my ($fh0, %fn, $gz, $bytes);
    my ($override);
    ($source, $type, $output) = @_;
    
    ($total, $val_counter) = (0, 0);
    # Open the log file }ҰO
    ($WORKING_SRC, $total, $working)  = open_src ($source, $type, $output);
    # If the log file is empty OɬOŪ
    return (0, 0) if $total == 0;
    
    # Check the log file format ˬdOɮ榡
    $entry = <$WORKING_SRC>;
    print STDERR "Checking the log file format... " if $VERBOSE >= 2;
    if ($entry =~ /^\S+ \S+ .*? \[(\d{2}\/[A-Z][a-z]{2}\/\d{4}:\d{2}:\d{2}:\d{2} [+\-]\d{4})\]/) {
        $DATE_RE = "^\\S+ \\S+ .*? \\[(\\d{2}\\/[A-Z][a-z]{2}\\/\\d{4}:\\d{2}:\\d{2}:\\d{2} [+\\-]\\d{4})\\]";
        print STDERR "Apache\n" if $VERBOSE >= 2;
    } elsif ($entry =~ /^([A-Z][a-z]{2}  ?\d{1,2} \d{2}:\d{2}:\d{2}) /) {
        $DATE_RE = "^([A-Z][a-z]{2}  ?\\d{1,2} \\d{2}:\\d{2}:\\d{2}) ";
        print STDERR "Syslog\n" if $VERBOSE >= 2;
    } else {
        print STDERR "unknown\n" if $VERBOSE >= 2;
        $! = 1;
        die "$THIS_FILE: Unrecognized log file format";
    }
    
    # Process the records one by one @@Bz
    undef $cur_month;
    do {
        next unless $entry =~ /$DATE_RE/;
        next unless defined ($_ = str2time $1);
        $month = to_yyyymm($_);
        
        # End the previous month WӤ
        if (defined $cur_month && $month ne $cur_month) {
            # This month -- don't close anything ɡAn
            if (defined $cur_month && $cur_month eq $THIS_MONTH && $KEEP eq "this-month") {
                print STDERR "done\n" if $VERBOSE >= 2;
                print STDERR "" . format_number($mon_counter{$THIS_MONTH}) . " records preserved for $THIS_MONTH\n" if $VERBOSE >= 1;
            
            # Previous file opened -- close it eӤɮפw}ɡA
            } elsif (defined $fh && defined fileno $fh) {
                flock $fh, LOCK_UN or die "$THIS_FILE: $!";
                close $fh or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
                print STDERR "" . format_number($mon_counter{$cur_month}) . " records archived for $cur_month\n" if $VERBOSE >= 1;
            
            # Ignored months -- report only A^έp
            } elsif (exists $fn{$cur_month} && !defined $fn{$cur_month}) {
                print STDERR "done\n" if $VERBOSE >= 2;
                print STDERR "" . format_number($mon_counter{$cur_month}) . " records ignored for $cur_month\n" if $VERBOSE >= 1;
            }
        }
        
        # Start a new month }lU@Ӥ
        if (!defined $cur_month || $month ne $cur_month) {
            # This month -- open a temporary working file ж}Ȧs
            if ($month eq $THIS_MONTH && $KEEP eq "this-month") {
                if (!defined $fh0) {
                    $fh0 = tempfile or die "$THIS_FILE: $!";
                    flock $fh0, LOCK_EX or die "$THIS_FILE: $!";
                }
                print STDERR "Preserving records of $month... " if $VERBOSE >= 2;
            
            # Other months -- open file oж}
            } else {
                # Inherit the previous temporary working file ~ӤeȮɤu@
                $fn{$month} = $FN{$month} if !exists $fn{$month} && exists $FN{$month};
                # First time -- open a new file Ĥ@ж}s
                if (!exists $fn{$month}) {
                    $fn{$month} = "$output.$month";
                    $fn{$month} .= $COMPRESS_SUFFIX if $COMPRESS ne "none";
                    
                    # Target file exists ɮפwsb
                    if (-e $fn{$month}) {
                        $override = $OVERRIDE;
                        # If we should ask pGn@@߰ݪ
                        while ($override eq "ask") {
                            print STDERR "$fn{$month} already exists, (O)verwrite, (A)ppend, (I)gnore, (F)ail? [F] ";
                            $_ = <STDIN>;
                            # Fail if not answered SnAN
                            if (!defined $_) {
                                print STDERR "\nArhh.. you are not here. I'd better drop it right now.\n";
                                $override = "fail";
                                last;
                            }
                            chomp;
                            # Overwrite \
                            if (lc $_ eq "o" || lc $_ eq "overwrite") {
                                $override = "overwrite";
                            # Append [Wh
                            } elsif (lc $_ eq "a" || lc $_ eq "append") {
                                $override = "append";
                            # Ignore 
                            } elsif (lc $_ eq "i" || lc $_ eq "ignore") {
                                $override = "ignore";
                            # Fail 
                            } elsif (lc $_ eq "f" || lc $_ eq "fail" || lc $_ eq "") {
                                $override = "fail";
                            # Else, ask again _hA
                            } else {
                                print STDERR "What?\n";
                                $override = "ask";
                            }
                        }
                        # Overwrite, do nothing \Aޥ
                        if ($override eq "overwrite") {
                        
                        # Append, handle when opening file [WhA}ɮɦABz
                        } elsif ($override eq "append") {
                        
                        # Ignore, undefine the filename A]ɦW
                        } elsif ($override eq "ignore") {
                            undef $fn{$month};
                        
                        # Else, stop processing A{
                        } else {
                            foreach (keys %mon_counter) {
                                unlink $fn{$_} or die "$THIS_FILE: $!";
                            }
                            die "$THIS_FILE: File exists $fn{$month}";
                        }
                    }
                    
                    # Ignore, open nothing An}
                    if (!defined $fn{$month}) {
                        print STDERR "Ignoring records of $month... " if $VERBOSE >= 2;
                    
                    # Append, output the original to temporary working files sWAlO]giȦsɤ
                    } elsif (-e $fn{$month} && $override eq "append") {
                        $FILE_TYPES{$fn{$month}} = check_file_type($fn{$month});
                        # Existing is a gzipped file ɬO gzip Y
                        if ($FILE_TYPES{$fn{$month}} =~ /gzip/i) {
                            check_gzip();
                            # Process with Compress::Zlib  Compress::Zlib Bz
                            if ($GZIP eq "Compress::Zlib") {
                                print STDERR "Reading original records of $month... " if $VERBOSE >= 2;
                                open ORIGINAL, $fn{$month} or die "$THIS_FILE: $!";
                                flock ORIGINAL, LOCK_SH or die "$THIS_FILE: $!";
                                $gz = gzopen(*ORIGINAL, "rb") or die "$THIS_FILE: $!";
                                ($fh, $fn{$month}) = tempfile or die "$THIS_FILE: $!";
                                $FN{$month} = $fn{$month};
                                flock $fh, LOCK_EX or die "$THIS_FILE: $!";
                                while (($bytes = $gz->gzreadline($_)) != 0) {
                                    die "$THIS_FILE: " . $gz->gzerror() if $bytes == -1;
                                    print $fh $_ or die "$THIS_FILE: $!";
                                }
                                flock ORIGINAL, LOCK_UN or die "$THIS_FILE: $!";
                                close ORIGINAL or die "$THIS_FILE: $!";
                                undef $gz;
                                print STDERR "done\n" if $VERBOSE >= 2;
                            
                            # Process with gzip  gzip Bz
                            } else {
                                print STDERR "Reading original records of $month... " if $VERBOSE >= 2;
                                open ORIGINAL, $fn{$month} or die "$THIS_FILE: $!";
                                flock ORIGINAL, LOCK_SH or die "$THIS_FILE: $!";
                                open TEMP, "$GZIP -d -c $fn{$month} |" or die "$THIS_FILE: $!";
                                ($fh, $fn{$month}) = tempfile or die "$THIS_FILE: $!";
                                $FN{$month} = $fn{$month};
                                flock $fh, LOCK_EX or die "$THIS_FILE: $!";
                                while (defined ($_ = <TEMP>)) {
                                    print $fh $_ or die "$THIS_FILE: $!";
                                }
                                flock ORIGINAL, LOCK_UN or die "$THIS_FILE: $!";
                                close ORIGINAL or die "$THIS_FILE: $!";
                                print STDERR "done\n" if $VERBOSE >= 2;
                            }
                        
                        # Existing is a bzipped file ɬO bzip2 Y
                        } elsif ($FILE_TYPES{$fn{$month}} =~ /bzip2/i) {
                            check_bzip2();
                            # Process with Compress::Bzip2  Compress::Bzip2 Bz
                            if ($BZIP2 eq "Compress::Bzip2") {
                                # Compress::Bzip2 is not practical yet ثe٤ Compress::Bzip2
                            
                            # Process with bzip2  bzip2 Bz
                            } else {
                                print STDERR "Reading original records of $month... " if $VERBOSE >= 2;
                                open ORIGINAL, $fn{$month} or die "$THIS_FILE: $!";
                                flock ORIGINAL, LOCK_SH or die "$THIS_FILE: $!";
                                open TEMP, "$BZIP2 -d -c $fn{$month} |" or die "$THIS_FILE: $!";
                                ($fh, $fn{$month}) = tempfile or die "$THIS_FILE: $!";
                                $FN{$month} = $fn{$month};
                                flock $fh, LOCK_EX or die "$THIS_FILE: $!";
                                while (defined ($_ = <TEMP>)) {
                                    print $fh $_ or die "$THIS_FILE: $!";
                                }
                                flock ORIGINAL, LOCK_UN or die "$THIS_FILE: $!";
                                close ORIGINAL or die "$THIS_FILE: $!";
                                print STDERR "done\n" if $VERBOSE >= 2;
                            }
                        
                        # Existing is a plain text file ɬO¤r
                        } elsif ($FILE_TYPES{$fn{$month}} =~ /text/i || $FILE_TYPES{$fn{$month}} =~ /empty/i) {
                            print STDERR "Reading original records of $month... " if $VERBOSE >= 2;
                            open ORIGINAL, $fn{$month} or die "$THIS_FILE: $!";
                            flock ORIGINAL, LOCK_SH or die "$THIS_FILE: $!";
                            ($fh, $fn{$month}) = tempfile or die "$THIS_FILE: $!";
                            $FN{$month} = $fn{$month};
                            flock $fh, LOCK_EX or die "$THIS_FILE: $!";
                            print $fh $_ while <ORIGINAL>;
                            flock ORIGINAL, LOCK_UN or die "$THIS_FILE: $!";
                            close ORIGINAL or die "$THIS_FILE: $!";
                            print STDERR "done\n" if $VERBOSE >= 2;
                        
                        # Not available 
                        } else {
                        }
                        print STDERR "Appending records of $month... " if $VERBOSE >= 2;
                    
                    # Open a temporary working file }Ȧs
                    } else {
                        print STDERR "Archiving records of $month... " if $VERBOSE >= 2;
                        ($fh, $fn{$month}) = tempfile or die "$THIS_FILE: $!";
                        $FN{$month} = $fn{$month};
                        flock $fh, LOCK_EX or die "$THIS_FILE: $!";
                    }
                
                # Opened before, append it }LաХ[̫᭱
                } else {
                    # Ignore, open nothing An}
                    if (!defined $fn{$month}) {
                        print STDERR "Ignoring records of $month... " if $VERBOSE >= 2;
                    
                    # Else, append _hA[̫᭱
                    } else {
                        print STDERR "Archiving records of $month... " if $VERBOSE >= 2;
                        open $fh, ">>$fn{$month}" or die "$THIS_FILE: $!";
                        flock $fh, LOCK_EX or die "$THIS_FILE: $!";
                    }
                }
            }
            $cur_month = $month;
        }
        
        # Save it sih
        # This month, save to $fh0 As $fh0
        if ($month eq $THIS_MONTH && $KEEP eq "this-month") {
            print $fh0 $entry or die "$THIS_FILE: $!";
        
        # Ignore, save nothing Ans
        } elsif (!defined $fn{$month}) {
        
        # Other months, save to $fh oAs $fh
        } else {
            print $fh $entry or die "$THIS_FILE: $!";
        }
        
        # Add the counter έp
        $mon_counter{$month} = 0 if !exists $mon_counter{$month};
        $mon_counter{$month}++;
        $val_counter++;
    } while defined ($entry = <$WORKING_SRC>);
    
    # Deal the archived records BzkɪO
    # Previous is this month -- report only eӤOɡAɡAiέp
    if ($cur_month eq $THIS_MONTH && $KEEP eq "this-month") {
        print STDERR "done\n" if $VERBOSE >= 2;
        print STDERR "" . format_number($mon_counter{$THIS_MONTH}) . " records preserved for $THIS_MONTH\n" if $VERBOSE >= 1;
    
    # Previous file opened -- close it oɮפw}ɡA
    } elsif (defined $fh && defined fileno $fh) {
        flock $fh, LOCK_UN or die "$THIS_FILE: $!";
        close $fh or die "$THIS_FILE: $!";
        print STDERR "done\n" if $VERBOSE >= 2;
        print STDERR "" . format_number($mon_counter{$cur_month}) . " records archived for $cur_month\n" if $VERBOSE >= 1;
    
    # Ignored months -- report only A^έp
    } elsif (!defined $fn{$cur_month}) {
        print STDERR "done\n" if $VERBOSE >= 2;
        print STDERR "" . format_number($mon_counter{$cur_month}) . " records ignored for $cur_month\n" if $VERBOSE >= 1;
    }
    
    # Delete the filenames of ignored months RɦW
    foreach (keys %fn) {
        delete $fn{$_} unless defined $fn{$_};
    }
    
    # Sort the archives by date/time ɶƧ
    sort_arcs (%fn) if $SORT;
    
    # Save the archives Nkɫ᪺Os
    save_arcs ($output, %fn);
    
    # Keep the records of this month OdoӤ몺O
    if ($KEEP eq "this-month" && defined $fh0 && defined fileno $fh0) {
        print STDERR "Returning records of $THIS_MONTH... " if $VERBOSE >= 2;
        # Return to a gzipped file hٵ gzip Y
        if ($type =~ /gzip/i) {
            check_gzip();
            # Process with Compress::Zlib  Compress::Zlib Bz
            if ($GZIP eq "Compress::Zlib") {
                # Open the source log file }ҭӪO
                open SOURCE2, "+<$source" or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_EX or die "$THIS_FILE: $!";
                open SOURCE, "+<$source" or die "$THIS_FILE: $!";
                # Add the new records حsO[Ȯɤu@
                $gz = gzopen(*SOURCE, "rb") or die "$THIS_FILE: $!";
                while (($bytes = $gz->gzreadline($_)) != 0) {
                    die "$THIS_FILE: " . $gz->gzerror() if $bytes == -1;
                    print $fh0 $_ or die "$THIS_FILE: $!";
                }
                # Close the source log file ӪO
                close SOURCE or die "$THIS_FILE: $!";
                # Restart the log file Oks
                seek SOURCE2, 0, 0 or die "$THIS_FILE: $!";
                truncate SOURCE2, 0 or die "$THIS_FILE: $!";
                seek $fh0, 0, 0 or die "$THIS_FILE: $!";
                $gz = gzopen(*SOURCE2, "wb9") or die "$THIS_FILE: $!";
                # Copy records to the log file Oh^O
                while (defined ($_ = <$fh0>)) {
                    $gz->gzwrite($_) or die "$THIS_FILE: " . $gz->gzerror();
                }
                # Close the log file O
                $gz->gzclose() and die "$THIS_FILE: " . $gz->gzerror();
                # Close this month's temporary file Ȧs
                flock $fh0, LOCK_UN or die "$THIS_FILE: $!";
                close $fh0 or die "$THIS_FILE: $!";
            
            # Process with gzip  gzip Bz
            } else {
                # Open the source log file }ҭӪO
                open SOURCE2, "+<$source" or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_EX or die "$THIS_FILE: $!";
                open SOURCE, "$GZIP -d -c $source |" or die "$THIS_FILE: $!";
                # Add the new records حsO[Ȯɤu@
                while (defined ($_ = <SOURCE>)) {
                    print $fh0 $_ or die "$THIS_FILE: $!";
                }
                # Close the source log file ӪO
                close SOURCE or die "$THIS_FILE: $!";
                # Restart the log file Oks
                seek SOURCE2, 0, 0 or die "$THIS_FILE: $!";
                truncate SOURCE2, 0 or die "$THIS_FILE: $!";
                seek $fh0, 0, 0 or die "$THIS_FILE: $!";
                # Start compressing }lY
                open TEMP, "| $GZIP -9 -c > $source" or die "$THIS_FILE: $!";
                # Pipe the records in Oih
                while (defined ($_ = <$fh0>)) {
                    print TEMP or die "$THIS_FILE: $!";
                }
                # End compressing Y
                close TEMP or die "$THIS_FILE: $!";
                # Close the log file O
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                # Close this month's temporary file Ȧs
                flock $fh0, LOCK_UN or die "$THIS_FILE: $!";
                close $fh0 or die "$THIS_FILE: $!";
            }
        
        # Return to a bzipped file hٵ bzip2 Y
        } elsif ($type =~ /bzip2/i) {
            check_bzip2();
            # Process with Compress::Bzip2  Compress::Bzip2 Bz
            if ($BZIP2 eq "Compress::Bzip2") {
                # Compress::Bzip2 is not practical yet ثe٤ Compress::Bzip2
            
            # Process with bzip2  bzip2 Bz
            } else {
                # Open the source log file }ҭӪO
                open SOURCE2, "+<$source" or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_EX or die "$THIS_FILE: $!";
                open SOURCE, "$BZIP2 -d -c $source |" or die "$THIS_FILE: $!";
                # Add the new records حsO[Ȯɤu@
                while (defined ($_ = <SOURCE>)) {
                    print $fh0 $_ or die "$THIS_FILE: $!";
                }
                # Close the source log file ӪO
                close SOURCE or die "$THIS_FILE: $!";
                # Restart the log file Oks
                seek SOURCE2, 0, 0 or die "$THIS_FILE: $!";
                truncate SOURCE2, 0 or die "$THIS_FILE: $!";
                seek $fh0, 0, 0 or die "$THIS_FILE: $!";
                # Start compressing }lY
                open TEMP, "| $BZIP2 -c > $source" or die "$THIS_FILE: $!";
                # Pipe the records in Oih
                while (defined ($_ = <$fh0>)) {
                    print TEMP or die "$THIS_FILE: $!";
                }
                # End compressing Y
                close TEMP or die "$THIS_FILE: $!";
                # Close the log file O
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                # Close this month's temporary file Ȧs
                flock $fh0, LOCK_UN or die "$THIS_FILE: $!";
                close $fh0 or die "$THIS_FILE: $!";
            }
        
        # Return to a plain text file hٵ¤r
        } else {
            # Open the source log file }ҭӪO
            open SOURCE, "+<$source" or die "$THIS_FILE: $!";
            flock SOURCE, LOCK_EX or die "$THIS_FILE: $!";
            # Add the new records حsO[Ȯɤu@
            print $fh0 $_ while $_ = <SOURCE>;
            # Restart the log file Oks
            seek SOURCE, 0, 0 or die "$THIS_FILE: $!";
            truncate SOURCE, 0 or die "$THIS_FILE: $!";
            seek $fh0, 0, 0 or die "$THIS_FILE: $!";
            # Copy records to the log file Oh^O
            print SOURCE while <$fh0>;
            # Close the log file O
            flock SOURCE, LOCK_UN or die "$THIS_FILE: $!";
            close SOURCE or die "$THIS_FILE: $!";
            # Close this month's temporary file Ȧs
            flock $fh0, LOCK_UN or die "$THIS_FILE: $!";
            close $fh0 or die "$THIS_FILE: $!";
        }
        print STDERR "done\n" if $VERBOSE >= 2;
        delete $mon_counter{$THIS_MONTH};
    }
    
    # Delete the temporary working file RȮɤu@
    if (defined $working) {
        print STDERR "Deleting $working... " if $VERBOSE >= 2;
        seek $WORKING_SRC, 0, 0 or die "$THIS_FILE: $!";
        truncate $WORKING_SRC, 0 or die "$THIS_FILE: $!";
        flock $WORKING_SRC, LOCK_UN or die "$THIS_FILE: $!";
        close $WORKING_SRC or die "$THIS_FILE: $!";
        unlink $working or die "$THIS_FILE: $!";
        print STDERR "done\n" if $VERBOSE >= 2;
    }
    
    return ($total, $val_counter);
}

# open_src: Open the log file }ҰO
sub open_src {
    local $_;
    my ($source, $type, $output, $working, $target, $total, $gz, $bytes);
    my ($pid, $IPCIN, $IPCOUT, $IPCERR);
    ($source, $type, $output) = @_;
    
    $total = 0;
    # Read the log file from STDIN ѼзǿJŪO
    if ($source eq "-") {
        # Open the temporary working file }ҼȮɤu@
        # STDIN records should deal with its record preservation by itself.
        # We'll use an anonymous temporary file here.
        # зǿJۤvnQkOdOAڭ̪Ȯɤu@ɤɦW
        $target = "the temporary working file";
        print STDERR "Creating $target... " if $VERBOSE >= 2;
        $WORKING_SRC = tempfile or die "$THIS_FILE: $!";
        print STDERR "done\n" if $VERBOSE >= 2;
        
        # Copy to the temporary working file ƻsȮɤu@
        print STDERR "Copying from STDIN to $target... " if $VERBOSE >= 2;
        while ($_ = <STDIN>) {
            print $WORKING_SRC $_ or die "$THIS_FILE: $!";
            $total++;
        }
        print STDERR "done\n" if $VERBOSE >= 2;
        
        # Empty file -- bounce directly ɡСЪ
        if ($total == 0) {
            print STDERR "No records read from STDIN\n" if $VERBOSE >= 1;
            
            # Close the temporary working file Ȯɤu@
            print STDERR "Closeing $target... " if $VERBOSE >= 2;
            close $WORKING_SRC or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            return ($WORKING_SRC, 0);
        }
        
        # Return the file reader ŪgYk
        seek $WORKING_SRC, 0, 0 or die "$THIS_FILE: $!";
    
    # Open the gzipped file } gzip Y
    } elsif ($type =~ /gzip/i) {
        # Open a temporary working file }ҼȮɤu@
        # When keep all, we can use an anonymous temporary working
        # file, since log records will never be lost.
        # OdOɡAΩȱOAȦsu@ɤɦWC
        if ($KEEP eq "all") {
            $target = "the temporary working file";
            print STDERR "Creating $target... " if $VERBOSE >= 2;
            $WORKING_SRC = tempfile or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
        
        # Otherwise we have to open a named temporary working file, so
        # that the log records are preserved in case the program stops
        # in the middle.
        # MܡANn}@ӦɦWȮɤu@ɡAHK{@b
        # _ɡABz@bOsUӡC
        } else {
            $working = $source;
            $working =~ s/\.gz$//;
            $working .= $TMP_SUFFIX;
            $target = $working;
            print STDERR "Creating $target... " if $VERBOSE >= 2;
            open $WORKING_SRC, "+>$working" or die "$THIS_FILE: $!";
            flock $WORKING_SRC, LOCK_EX or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
        }
        
        check_gzip();
        # Process with Compress::Zlib  Compress::Zlib Bz
        if ($GZIP eq "Compress::Zlib") {
            # Open the source }ҭO
            # Open a second time to the same file, so that we can
            # do both gzopen("rb") and gzopen("wb") in order to the
            # same file within the same flock().
            # P@ɶ}⦸AHKڭ̥iHbP@ɮצP@q flock
            # ɶAᰵ gzopen("rb") and gzopen("wb") C
            print STDERR "Opening $source... " if $VERBOSE >= 2;
            open SOURCE2, "+<$source" or die "$THIS_FILE: $!";
            flock SOURCE2, LOCK_EX or die "$THIS_FILE: $!";
            open SOURCE, "+<$source" or die "$THIS_FILE: $!";
            $gz = gzopen(*SOURCE, "rb") or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Copy to the temporary working file ƻsȮɤu@
            print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
            while (($bytes = $gz->gzreadline($_)) != 0) {
                die "$THIS_FILE: " . $gz->gzerror() if $bytes == -1;
                print $WORKING_SRC $_ or die "$THIS_FILE: $!";
                $total++;
            }
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Close the source O
            # Keep the source OdO
            if ($KEEP eq "all") {
                # Close the source O
                print STDERR "Closing $source... " if $VERBOSE >= 2;
                close SOURCE or die "$THIS_FILE: $!";
                undef $gz;
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            
            # Delete the source RO
            } elsif ($KEEP eq "delete") {
                # Close the source O
                print STDERR "Closing $source... " if $VERBOSE >= 2;
                seek SOURCE, 0, 0 or die "$THIS_FILE: $!";
                truncate SOURCE, 0 or die "$THIS_FILE: $!";
                close SOURCE or die "$THIS_FILE: $!";
                undef $gz;
                print STDERR "done\n" if $VERBOSE >= 2;
                
                # Delete the source RO
                print STDERR "Deleting $source... " if $VERBOSE >= 2;
                unlink $source or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            
            # Restart the source ksO
            } else {
                # Close the source O
                print STDERR "Closing $source... " if $VERBOSE >= 2;
                close SOURCE or die "$THIS_FILE: $!";
                undef $gz;
                print STDERR "done\n" if $VERBOSE >= 2;
                
                # Restart the source ksO
                print STDERR "Restarting $source... " if $VERBOSE >= 2;
                seek SOURCE2, 0, 0 or die "$THIS_FILE: $!";
                truncate SOURCE2, 0 or die "$THIS_FILE: $!";
                $gz = gzopen(*SOURCE2, "wb9") or die "$THIS_FILE: $!";
                $gz->gzclose();
                print STDERR "done\n" if $VERBOSE >= 2;
            }
        
        # Process with gzip  gzip Bz
        } else {
            # Start uncompressing }lY
            # Open a second time to the same file, so that we can
            # do gunzip to the same file within the same flock().
            # P@ɶ}⦸AHKڭ̥iHbP@ɮצP@q flock
            # ɶA gunzip C
            print STDERR "Starting to uncompress $source... " if $VERBOSE >= 2;
            open SOURCE2, "+<$source" or die "$THIS_FILE: $!";
            flock SOURCE2, LOCK_EX or die "$THIS_FILE: $!";
            open SOURCE, "$GZIP -d -c $source |" or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Save to the temporary working file sȮɤu@
            print STDERR "Saving records to $target... " if $VERBOSE >= 2;
            while (defined ($_ = <SOURCE>)) {
                print $WORKING_SRC $_ or die "$THIS_FILE: $!";
                $total++;
            }
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # End uncompressing Y
            # Keep the source OdO
            if ($KEEP eq "all") {
                # End uncompressing Y
                print STDERR "Closing the uncompressing process... " if $VERBOSE >= 2;
                close SOURCE or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            
            # Delete the source RO
            } elsif ($KEEP eq "delete") {
                # End uncompressing Y
                print STDERR "Closing the uncompressing process... " if $VERBOSE >= 2;
                close SOURCE or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
                
                # Delete the source RO
                print STDERR "Deleting $source... " if $VERBOSE >= 2;
                unlink $source or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            
            # Restart the source ksO
            } else {
                # End uncompressing Y
                print STDERR "Closing the uncompressing process... " if $VERBOSE >= 2;
                close SOURCE or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
                
                # Restart the source ksO
                print STDERR "Restarting $source... " if $VERBOSE >= 2;
                seek SOURCE2, 0, 0 or die "$THIS_FILE: $!";
                truncate SOURCE2, 0 or die "$THIS_FILE: $!";
                open TEMP, "$GZIP -9 -c < /dev/null |" or die "$THIS_FILE: $!";
                while (defined ($_ = <TEMP>)) {
                    print SOURCE2 or die "$THIS_FILE: $!";
                }
                close TEMP or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            }
        }
        
        # Empty file -- bounce directly ɡСЪ
        if ($total == 0) {
            print STDERR "No records read from $source\n" if $VERBOSE >= 1;
            
            # We have a named temporary working file ɦWȮɤu@
            if (defined $working) {
                # Close the temporary working file Ȯɤu@
                print STDERR "Closeing $target... " if $VERBOSE >= 2;
                flock $WORKING_SRC, LOCK_UN or die "$THIS_FILE: $!";
                close $WORKING_SRC or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
                
                # Delete the temporary working file RȮɤu@
                print STDERR "Deleting $target... " if $VERBOSE >= 2;
                unlink $working or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            
            # An anonymous temporary working file LɦWȮɤu@
            } else {
                # Close the temporary working file Ȯɤu@
                print STDERR "Closeing $target... " if $VERBOSE >= 2;
                close $WORKING_SRC or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            }
            return ($WORKING_SRC, 0);
        }
        
        # Return the file reader ŪgYk
        seek $WORKING_SRC, 0, 0 or die "$THIS_FILE: $!";
    
    # Open the bzipped file } bzip2 Y
    } elsif ($type =~ /bzip2/i) {
        # Open a temporary working file }ҼȮɤu@
        # When keep all, we can use an anonymous temporary working
        # file, since log records will never be lost.
        # OdOɡAΩȱOAȦsu@ɤɦWC
        if ($KEEP eq "all") {
            $target = "the temporary working file";
            print STDERR "Creating $target... " if $VERBOSE >= 2;
            $WORKING_SRC = tempfile or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
        
        # Otherwise we have to open a named temporary working file, so
        # that the log records are preserved in case the program stops
        # in the middle.
        # MܡANn}@ӦɦWȮɤu@ɡAHK{@b
        # _ɡABz@bOsUӡC
        } else {
            $working = $source;
            $working =~ s/\.bz2$//;
            $working .= $TMP_SUFFIX;
            $target = $working;
            print STDERR "Creating $target... " if $VERBOSE >= 2;
            open $WORKING_SRC, "+>$working" or die "$THIS_FILE: $!";
            flock $WORKING_SRC, LOCK_EX or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
        }
        
        check_bzip2();
        # Process with Compress::Bzip2  Compress::Bzip2 Bz
        if ($BZIP2 eq "Compress::Bzip2") {
            # Compress::Bzip2 is not practical yet ثe٤ Compress::Bzip2
        
        # Process with bzip2  bzip2 Bz
        } else {
            # Start uncompressing }lY
            # Open a second time to the same file, so that we can
            # do bunzip2 to the same file within the same flock().
            # P@ɶ}⦸AHKڭ̥iHbP@ɮצP@q flock
            # ɶA bunzip2 C
            print STDERR "Starting to uncompress $source... " if $VERBOSE >= 2;
            open SOURCE2, "+<$source" or die "$THIS_FILE: $!";
            flock SOURCE2, LOCK_EX or die "$THIS_FILE: $!";
            open SOURCE, "$BZIP2 -d -c $source |" or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Save to the temporary working file sȮɤu@
            print STDERR "Saving records to $target... " if $VERBOSE >= 2;
            while (defined ($_ = <SOURCE>)) {
                print $WORKING_SRC $_ or die "$THIS_FILE: $!";
                $total++;
            }
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # End uncompressing Y
            # Keep the source OdO
            if ($KEEP eq "all") {
                # End uncompressing Y
                print STDERR "Closing the uncompressing process... " if $VERBOSE >= 2;
                close SOURCE or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            
            # Delete the source RO
            } elsif ($KEEP eq "delete") {
                # End uncompressing Y
                print STDERR "Closing the uncompressing process... " if $VERBOSE >= 2;
                close SOURCE or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
                
                # Delete the source RO
                print STDERR "Deleting $source... " if $VERBOSE >= 2;
                unlink $source or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            
            # Restart the source ksO
            } else {
                # End uncompressing Y
                print STDERR "Closing the uncompressing process... " if $VERBOSE >= 2;
                close SOURCE or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
                
                # Restart the source ksO
                print STDERR "Restarting $source... " if $VERBOSE >= 2;
                seek SOURCE2, 0, 0 or die "$THIS_FILE: $!";
                truncate SOURCE2, 0 or die "$THIS_FILE: $!";
                open TEMP, "$BZIP2 -c < /dev/null |" or die "$THIS_FILE: $!";
                while (defined ($_ = <TEMP>)) {
                    print SOURCE2 or die "$THIS_FILE: $!";
                }
                close TEMP or die "$THIS_FILE: $!";
                flock SOURCE2, LOCK_UN or die "$THIS_FILE: $!";
                close SOURCE2 or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            }
        }
        
        # Empty file -- bounce directly ɡСЪ
        if ($total == 0) {
            print STDERR "No records read from $source\n" if $VERBOSE >= 1;
            
            # We have a named temporary working file ɦWȮɤu@
            if (defined $working) {
                # Close the temporary working file Ȯɤu@
                print STDERR "Closeing $target... " if $VERBOSE >= 2;
                flock $WORKING_SRC, LOCK_UN or die "$THIS_FILE: $!";
                close $WORKING_SRC or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
                
                # Delete the temporary working file RȮɤu@
                print STDERR "Deleting $target... " if $VERBOSE >= 2;
                unlink $working or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            
            # An anonymous temporary working file LɦWȮɤu@
            } else {
                # Close the temporary working file Ȯɤu@
                print STDERR "Closeing $target... " if $VERBOSE >= 2;
                close $WORKING_SRC or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            }
            return ($WORKING_SRC, 0);
        }
        
        # Return the file reader ŪgYk
        seek $WORKING_SRC, 0, 0 or die "$THIS_FILE: $!";
    
    # Open the plain text file }ү¤r
    } else {
        # Empty file -- bounce directly ɡСЪ
        if (-z $source) {
            print STDERR "No records read from $source\n" if $VERBOSE >= 1;
            # Delete the source RO
            if ($KEEP eq "delete") {
                print STDERR "Deleting $source... " if $VERBOSE >= 2;
                unlink $source or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            }
            return ($WORKING_SRC, 0);
        }
        
        # Ordinary file @ɮ
        # Keep all, copy to a temporary file OdOɡAƻsȮɤu@
        # Open the source read-only ΰŪ}ҭOɧYi
        if ($KEEP eq "all") {
            # Open the temporary working file }ҼȮɤu@
            $target = "the temporary working file";
            print STDERR "Creating $target... " if $VERBOSE >= 2;
            $WORKING_SRC = tempfile or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Open the source }ҭO
            print STDERR "Opening $source... " if $VERBOSE >= 2;
            open SOURCE, $source or die "$THIS_FILE: $!";
            flock SOURCE, LOCK_SH or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Copy to the temporary working file ƻsȮɤu@
            print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
            while ($_ = <SOURCE>) {
                print $WORKING_SRC $_ or die "$THIS_FILE: $!";
                $total++;
            }
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Close the source O
            print STDERR "Closing $source... " if $VERBOSE >= 2;
            flock SOURCE, LOCK_UN or die "$THIS_FILE: $!";
            close SOURCE or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
        
        # Else, copy to a temporary file and restart _hAƻsȮɤu@ɨçks
        # Open the source read-write ŪgҦ}ҭO
        } else {
            # Open the temporary working file }ҼȮɤu@
            $working = $output . $TMP_SUFFIX;
            $target = $working;
            print STDERR "Creating $target... " if $VERBOSE >= 2;
            open $WORKING_SRC, "+>$working" or die "$THIS_FILE: $!";
            flock $WORKING_SRC, LOCK_EX or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Open the source }ҭO
            print STDERR "Opening $source... " if $VERBOSE >= 2;
            open SOURCE, "+<$source" or die "$THIS_FILE: $!";
            flock SOURCE, LOCK_EX or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Copy to the temporary working file ƻsȮɤu@
            print STDERR "Copying from $source to $target... " if $VERBOSE >= 2;
            while ($_ = <SOURCE>) {
                print $WORKING_SRC $_ or die "$THIS_FILE: $!";
                $total++;
            }
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Restart the source Oks
            print STDERR "Restarting $source... " if $VERBOSE >= 2;
            seek SOURCE, 0, 0 or die "$THIS_FILE: $!";
            truncate SOURCE, 0 or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Close the source O
            print STDERR "Closing $source... " if $VERBOSE >= 2;
            flock SOURCE, LOCK_UN or die "$THIS_FILE: $!";
            close SOURCE or die "$THIS_FILE: $!";
            print STDERR "done\n" if $VERBOSE >= 2;
            
            # Delete the source RO
            if ($KEEP eq "delete") {
                print STDERR "Deleting $source... " if $VERBOSE >= 2;
                unlink $source or die "$THIS_FILE: $!";
                print STDERR "done\n" if $VERBOSE >= 2;
            }
        }
        
        # Return the file reader ŪgYk
        seek $WORKING_SRC, 0, 0 or die "$THIS_FILE: $!";
    }
    
    print STDERR "" . format_number($total) . " entries found in " . ($source eq "-"? "STDIN": $source) . "\n"  if $VERBOSE >= 1;
    
    return ($WORKING_SRC, $total, $working);
}

# sort_arcs: Sort the archives by date/time ɶƧ
sub sort_arcs {
    local $_;
    my ($month, %fn, %order, $date, $cur_date, $num_format);
    %fn = @_;
    
    $num_format = "%0" . (int ((log $SORT_SIZE_LIMIT) / (log 10)) + 1) . "d";
    
    # Sort each file CɮױƧ
    foreach $month (sort keys %fn) {
        print "Sorting records of $month... " if $VERBOSE >= 2;
        # Abort if over the limit WLjpWN
        if (-s $fn{$month} > $SORT_SIZE_LIMIT) {
            print "failed.\n" if $VERBOSE >= 2;
            print STDERR "$THIS_FILE: Too many records. Abort.\n";
            next;
        
        # Sort directly if less than 50MB  50MB Ƨ
        } else {
            open DATA, "+<$fn{$month}" or die "$THIS_FILE: $!";
            flock DATA, LOCK_EX or die "$THIS_FILE: $!";
            @_ = <DATA>;
            %order = qw();
            for ($_ = 0; $_ < @_; $_++) {
                $_[$_] =~ /$DATE_RE/;
                $order{str2time($1) . " " . sprintf($num_format, $_)} = $_;
            }
            seek DATA, 0, 0 or die "$THIS_FILE: $!";
            truncate DATA, 0 or die "$THIS_FILE: $!";
            foreach (sort keys %order) {
                if (!defined $_[$order{$_}]) {
                    print "$month: \"$_\" \"$order{$_}\" \"$_[$order{$_}]\"\n";
                    <STDIN>;
                }
                print DATA $_[$order{$_}] or die "$THIS_FILE: $!";
            }
            flock DATA, LOCK_UN or die "$THIS_FILE: $!";
            close DATA or die "$THIS_FILE: $!";
        }
        print "done\n" if $VERBOSE >= 2;
    }
    return;
}

# save_arcs: Save the archives Nkɫ᪺Os
sub save_arcs {
    local $_;
    my ($output, $month, $path, $file, $gz, $size_src, $size_comp, $ratio, %tmpfn);
    ($output, %tmpfn) = @_;
    
    # Save each file from the temporary working files qȦsɤs
    foreach $month (sort keys %tmpfn) {
        # Obtain the filename oɦW
        $path = "$output.$month";
        $path .= $COMPRESS_SUFFIX if $COMPRESS ne "none";
        $file = basename($path);
        $size_src = -s $tmpfn{$month};
        
        # Save s
        print "Saving records of $month to $path... " if $VERBOSE >= 2;
        # Compress with gzip  gzip Y
        if ($COMPRESS eq "gzip") {
            check_gzip();
            # Process with Compress::Zlib  Compress::Zlib Bz
            if ($GZIP eq "Compress::Zlib") {
                # Open the temporary working file }ҼȦs
                open TEMP, $tmpfn{$month} or die "$THIS_FILE: $!";
                flock TEMP, LOCK_SH or die "$THIS_FILE: $!";
                
                # Write to a compressed file gYɤ
                $gz = gzopen($path, "wb9") or die "$THIS_FILE: $!";
                while (defined ($_ = <TEMP>)) {
                    $gz->gzwrite($_) or die "$THIS_FILE: " . $gz->gzerror();
                }
                $gz->gzclose() and die "$THIS_FILE: " . $gz->gzerror();
                
                # Close the temporary working file Ȧs
                flock TEMP, LOCK_UN or die "$THIS_FILE: $!";
                close TEMP or die "$THIS_FILE: $!";
            
            # Process with gzip  gzip Bz
            } else {
                # Start compressing }lY
                open TEMP, "$GZIP -9 -c $tmpfn{$month} |" or die "$THIS_FILE: $!";
                
                # Write to an ordinary file g@ɤ
                open RESULT, ">$path" or die "$THIS_FILE: $!";
                flock RESULT, LOCK_EX or die "$THIS_FILE: $!";
                print RESULT while <TEMP>;
                flock RESULT, LOCK_UN or die "$THIS_FILE: $!";
                close RESULT or die "$THIS_FILE: $!";
                
                # End compressing Y
                close TEMP or die "$THIS_FILE: $!";
            }
        
        # Compress with bzip2  bzip2 Y
        } elsif ($COMPRESS eq "bzip2") {
            check_bzip2();
            # Process with Compress::Bzip2  Compress::Bzip2 Bz
            if ($BZIP2 eq "Compress::Bzip2") {
                # Compress::Bzip2 is not practical yet ثe٤ Compress::Bzip2
            
            # Process with bzip2  bzip2 Bz
            } else {
                # Start compressing }lY
                open TEMP, "$BZIP2 -c $tmpfn{$month} |" or die "$THIS_FILE: $!";
                
                # Write to an ordinary file g@ɤ
                open RESULT, ">$path" or die "$THIS_FILE: $!";
                flock RESULT, LOCK_EX or die "$THIS_FILE: $!";
                print RESULT while <TEMP>;
                flock RESULT, LOCK_UN or die "$THIS_FILE: $!";
                close RESULT or die "$THIS_FILE: $!";
                
                # End compressing Y
                close TEMP or die "$THIS_FILE: $!";
            }
        
        # No compression Y
        } else {
            # Open the temporary working file }ҼȦs
            open TEMP, $tmpfn{$month} or die "$THIS_FILE: $!";
            flock TEMP, LOCK_SH or die "$THIS_FILE: $!";
            
            # Write to an ordinary file g@ɤ
            open RESULT, ">$path" or die "$THIS_FILE: $!";
            flock RESULT, LOCK_EX or die "$THIS_FILE: $!";
            print RESULT while <TEMP>;
            flock RESULT, LOCK_UN or die "$THIS_FILE: $!";
            close RESULT or die "$THIS_FILE: $!";
            
            # Close the temporary working file Ȧs
            flock TEMP, LOCK_UN or die "$THIS_FILE: $!";
            close TEMP or die "$THIS_FILE: $!";
        }
        # Close the temporary working file Ȧs
        print "done\n" if $VERBOSE >= 2;
        
        # Report the statistics ^έpƦr
        if ($COMPRESS ne "none") {
            $size_comp = -s $path;
            $ratio = sprintf "%4.2f", ($size_comp/$size_src)*100;
            $size_src = format_number($size_src);
            $size_comp = format_number($size_comp);
            print "$file compressed from $size_src bytes to $size_comp bytes, ratio $ratio%\n" if $VERBOSE >= 1;
        }
    }
    return;
}

# check_file_type: Check the file format ˬdɮ׮榡
{
    my ($method, $mm, $file_magic);
    sub check_file_type {
        local ($_, %_);
        my ($file, $type);
        $file = $_[0];
        
        # Not set method before ٨S]Lˬdk
        if (!defined $method) {
            # Find the method to check file type ]wˬdɮ׫Ak
            {
                # Check if we have File::MMagic ˬdS File::MMagic
                eval {
                    require File::MMagic;
                };
                # Found F
                if ($@ eq "") {
                    $method = "pm";
                    $mm = new File::MMagic;
                    last;
                }
                # Not found S
                $@ =~ s/^(Can't locate \S+ in \@INC).*\n/$1\n/;
                print STDERR "$@" if $VERBOSE >= 1;
                
                # Looking for file from PATH q PATH  file
                print STDERR "Looking for file... " if $VERBOSE >= 1;
                $file_magic = whereis("file");
                # Found in PATH b PATH اF
                if (defined $file_magic) {
                    $method = "file";
                    print STDERR "$file_magic\n" if $VERBOSE >= 1;
                    last;
                }
                
                # Check by file name suffix ɧP_
                $method = "suffix";
                print STDERR "no\n" if $VERBOSE >= 1;
                print STDERR "$THIS_FILE: We'll check by file name suffix instead\n" if $VERBOSE >= 1;
            }
        }
        
        # Check the file format ˬdɮ׮榡
        # Check by File::MMagic  File::MMagic ˬd
        if ($method eq "pm") {
            $type = $mm->checktype_filename($file);
        
        # Check by the file program  file {ˬd
        } elsif ($method eq "file") {
            open DATA, "$file_magic $file |" or die "$THIS_FILE: $!";
            @_ = <DATA>;
            close DATA or die "$THIS_FILE: $!";
            $type = join "", @_;
        
        # Check by file name suffix ɧˬd
        } elsif ($method eq "suffix") {
            if ($file =~ /\.gz$/) {
                $type = "application/x-gzip";
            } elsif ($file =~ /\.bz2$/) {
                $type = "application/x-bzip2";
            # Otherwise assume to be text/plain o] text/plain
            } else {
                $type = "text/plain";
            }
        }
        
        return $type;
    }
}

# check_gzip: Check for compression method of gzip ˬd gzip Y覡
sub check_gzip {
    local ($_, %_);
    
    # Checked before ˬdLF
    return if defined $GZIP;
    
    # See whether Compress::Zlib or gzip ݭn Compress::Zlib ٬O gzip
    # Try Compress::Zlib first  Compress::Zlib
    eval {
        require Compress::Zlib;
        import Compress::Zlib qw(gzopen);
    };
    # Found F
    if ($@ eq "") {
        $GZIP = "Compress::Zlib";
        return;
    }
    # Not found S
    $@ =~ s/^(Can't locate \S+ in \@INC).*\n/$1\n/;
    print STDERR "$@" if $VERBOSE >= 1;
    
    # Looking for gzip from PATH q PATH  gzip
    print STDERR "Looking for gzip... " if $VERBOSE >= 1;
    $GZIP = whereis("gzip");
    # Found in PATH b PATH اF
    if (defined $GZIP) {
        print STDERR "$GZIP\n" if $VERBOSE >= 1;
        return;
    }
    # Still not found ٬OS
    print STDERR "no :(\n" if $VERBOSE >= 1;
    
    die "$THIS_FILE: Necessary Compress::Zlib or gzip not available.\n";
}

# check_bzip2: Check for compression method of bzip2 ˬd bzip2 Y覡
sub check_bzip2 {
    local ($_, %_);
    
    # Checked before ˬdLF
    return if defined $BZIP2;
    
    # See whether Compress::Bzip2 or bzip2 ݭn Compress::Bzip2 ٬O bzip2
    # Compress::Bzip2 is still not very practical, since currently it can
    # only do compress and uncompress raw data.  But our source log files
    # are often very large (often several tens of MBs.  That's why we need
    # to archive them).  It's not possible to compress and uncompress them
    # in the RAM.  We need to compress and uncompress data from files.  We
    # need support for BZ2_bzopen() and BZ2_bzdopen(), Brian~!
    # Compress::Bzip2 ثeuYMYASΡCOɳq`
    # ܤj]ʻƤQ MB AMFkɡH ^^; ^AnbɮפWYY
    # AibOWBzC Brian ADDp[W BZ2_bzopen() M
    # BZ2_bzdopen() aI
    # Try Compress::Bzip2 first  Compress::Bzip2
#    eval {
#        require Compress::Bzip2;
#    };
    # Found F
#    if ($@ eq "") {
#        $BZIP2 = "Compress::Bzip2";
#        return;
#    }
    # Not found S
#    $@ =~ s/^(Can't locate \S+ in \@INC).*\n/$1\n/;
#    print STDERR "$@" if $VERBOSE >= 1;
    
    # Looking for bzip2 from PATH q PATH  bzip2
    print STDERR "Looking for bzip2... " if $VERBOSE >= 1;
    $BZIP2 = whereis("bzip2");
    # Found in PATH b PATH اF
    if (defined $BZIP2) {
        print STDERR "$BZIP2\n" if $VERBOSE >= 1;
        return;
    }
    # Still not found ٬OS
    print STDERR "no :(\n" if $VERBOSE >= 1;
    
#    die "$THIS_FILE: Necessary Compress::Bzip2 or bzip2 not available.\n";
    die "$THIS_FILE: Necessary bzip2 not available.\n";
}

# whereis: Find an executable M
sub whereis {
    local ($_, %_);
    my ($bin);
    $bin = $_[0];
    @_ = split /:/, $ENV{"PATH"};
    foreach (@_) {
        return "$_/$bin" if -x "$_/$bin";
    }
    return;
}

# to_yyyymm: convert timestamp to yyyymm Nɶର yyyymm 榡
sub to_yyyymm {
    local $_;
    @_ = localtime $_[0];
    return sprintf "%04d%02d", $_[5] + 1900, $_[4] + 1;
}

# format_number: Format the number every 3 digit ƦrCTƥ[@J
sub format_number {
    local $_;
    $_ = $_[0];
    # Group every 3 digit CTƥ[@J
    $_ = $1 . "," . $2 . $3 while /^([^\.]*\d)(\d\d\d)(.*)$/;
    return $_;
}

# rel2abs: Convert a relative path to an absolute path ۹|ର|
sub rel2abs {
    local $_;
    my ($user, $path, $base);
    ($path, $base) = @_;
    
    # Turn the base absolute Ҭ۹諸|ন|
    $base = cwd unless defined $base;
    $base = rel2abs ($base) if !file_name_is_absolute $base;
    
    # Deal the ~ home directories under UNIX b UNIX UBz ~ ϥΪ̪ڥؿ
    if (defined $Config{"d_getpwent"}) {
        @_ = splitdir ($path);
        # If start from user's home directory YOqϥΪ̮ڥؿ}l
        if ($_[0] =~ /^~(.*)$/) {
            $user = $1;
            # Get the current user if user not specified YϥΪ̨S]wAHثeϥΪ̬
            $user = getlogin if $user eq "";
            # Get the user home directory oϥΪ̮ڥؿ
            $_ = (getpwnam $user)[7];
            # Replace with the user home directory NϥΪ̮ڥؿ
            $_[0] = $_ if defined $_;
            # Compose the path զX|
            $path = catfile @_;
        }
    }
    
    # Append the current directory if relative ۹|Wثe|
    $path = catfile ($base, $path) unless file_name_is_absolute $path;
    
    @_ = splitdir ($path);          # Split into directory components Uhؿ
    # Add an empty filename level if last level is a directory ̫@hOؿɡA[WťɦWh
    push @_, "" if ($_[@_-1] eq curdir || $_[@_-1] eq updir);
    for ($_ = 1; $_ < @_; $_++) {   # Parse each level one by one @h@hR
        # If it is this directory oӥؿ
        if ($_[$_] eq curdir) {
            splice (@_, $_, 1);     # Remove this level directly ho@h
            $_--;                   # The level number drop by 1 hƴ@
        # If it is the parent directory W@hؿ
        } elsif ($_ > 1 && $_[$_] eq updir && $_[$_-1] ne updir) {
            splice (@_, $_-1, 2);   # Remove this and the previous level ho@hMW@h
            $_ -= 2;                # The level number drop by 2 hƴG
        }
    }
    $path = catfile (@_);            # Compose the full path զX|
    return $path;
}

__END__

=head1 NAME

arclog.pl - Archive log files monthly

=head1 SYNOPSIS

 arclog.pl [options] logfile... [output]
 arclog.pl [-h|-v]

=head1 DESCRIPTION

F<arclog.pl> archives log files monthly.  It strips off log entries
that belongs to previous months, and then compresses and saves them
to archived files named logfile.yyyymm.gz.  Currently, only Apache
access_log and L<Syslog(2)|syslog/2> formats are recognized.

Notice: I<Archiving takes time>.  From version 2.0.0, it will copy
the source log file to a temporary working file and restart it first.
Then it can take its time working on that temporary working file.
This can maximum reduce the time occupying the source log file,
avoiding the need of foreign log file restarting program.  However,
please note:  (1) If you have a huge log file (several tenths of
MBs), it still sucks copying.  You had better stop logging first,
archive the log file and restart logging, to avoid racing condition
in writing.  If you archive the log file periodly, it shall not grow
too big.  (2) If it stops in the middle of execution, it will leave
a temporary working file.  The next time it runs, it will stop when
it sees that temporary working file at the first sight.  You have to
process that file first in order to keep working.  You can change it
to a different filename and archive it like an ordinary log file, to
solve this.

You can optionally sort the records in the archived files by time
(and then by record order), to solve some problems on merged log
files.  But I<BE CAUTIONED>:  Sorting eats huge memory and CPU.  If
you work on large log files, it may kill the whole system in one
minute.  I had made some simple steps to avoid that, but I<I CAN'T
GUARANTEE THAT IT WORKS>.  Whether it kills depends on which CPU you
have, how much memory you have and how large your archived file is.
Because of this, sorting is by default turned off.

Be careful on the L<Syslog(2)|syslog/2> log files:
L<Syslog(2)|syslog/2> does not record the year.  F<arclog.pl> uses
L<Date::Parse(3)|Date::Parse/3> to parse the date, which smartly
judges the year between this month and last next month.  For ex., if
today is 2001-06-08, it will then judges the year between 2001-06-30
back to 2000-07-01 if the year is missing.  I think this is smart
enough.  However, if you do have a L<Syslog(2)|syslog/2> log file
that has records older than one year, don't use F<arclog.pl>.  It
will destroy your log file.

From version 1.5.0 you can specify C<-> to read from C<STDIN>.  But
notice here: (1) You I<MUST> specify the output prefix if you want to
read from C<STDIN>, since what it needs is an output pathname prefix,
not an output file.  (2) If you read from a file, the records of this
month will be returned to that file, to be archived next month; but
if you read from C<STDIN>, there's no place to return the records, so
the records of this month will be archived, too.  (3) The answers of
the C<ask> mode is obtained from C<STDIN>, too.  Since you have only
one C<STDIN>, you cannot specify the C<ask> mode while reading from
C<STDIN>.  It will fall back to the C<fail> mode in that case.  (4)
You cannot read compressed log files from C<STDIN>.  This is not
implemented yet.

=head1 OPTIONS

=over

=item logfile

The log file to be archived.  Specify C<-> to read from C<STDIN>.
Multiple log files are supported.  L<gzip(1)|gzip/1> or
L<bzip2(1)|bzip2/1> compressed files are supported, too.

=item output

The prefix of the output files.  The output files will be named as
F<output.yyyymm>, ie: F<output.200101>, F<output.200101>.  If not
specified, the default is the same as the log file.  You must specify
this if you want to read from C<STDIN>.  You cannot specify C<->
(C<STDIN>), since this is only a name prefix, not the output file.

=item -c,--compress[=method]

Specify the compression method for the archived files.  Log files
usually have large number of simular lines.  Compress them saves
you lots of disk spaces.  (And this is why we want to I<archive>
them.)  Currently the following compression methods are supported:

=over

=item g,gzip

Compress with L<gzip(1)|gzip/1>.  This is the default.  F<arclog.pl>
can use L<Compress::Zlib(3)|Compress::Zlib/3> to compress instead of
calling L<gzip(1)|gzip/1>.  This can be safer and faster for not
calling foreign binaries.  But if
L<Compress::Zlib(3)|Compress::Zlib/3> is not installed, it will try
to use L<gzip(1)|gzip/1> instead.  If L<gzip(1)|gzip/1> is not
available, either, the program will fail.

=item b,bzip2

Compress with L<bzip2(1)|bzip2/1>.  Because
L<Compress::Bzip2(3)|Compress::Bzip2/3> has still very limited
bzip2 library support, F<arclog.pl> will always use
L<bzip2(1)|bzip2/1> binary.  If L<bzip2(1)|bzip2/1> binary is not
available, the program will fail here.

=item n,none

No compression at all.  (Why? :p)

=back

=item --nocompress

Don't compress the archived files.  This is equal to
C<--compress=none>.

=item -s,--sort

Sort the records by time (and then the record order).  Sorting eats
huge memory and CPU, so it is disabled by default.  See the
description above for a detailed illustration on sorting.

=item --nosort

Don't sort the records.  This is the default.

=item -o,--override[=mode]

Whether we should overwrite the existing archived files.  Currently
the following modes are supported:

=over

=item o,overwrite

Overwrite existing target files.  If C<--override> was specified
without C<mode>, it assumes that you want to overwrite.  You will
lost these existing records.  Use with care.  This is helpful if you
are sure the master log file has the most complete records.

=item a,append

Append the records to the existing target files.  You may destroy the
log file completely by putting irrelevant entries altogether
accidently.  Use with care.  This is helpful if you append want to
merge 2 or more log files, for ex., 2 log files of different periods.

=item i,ignore

Ignore any existing target file, and discard all the records of those
months.  You will lost these log records.  Use with care.  This is
helpful if you are supplying log records for the missing months, or
if you are merging the log records in a complex manner.

=item f,fail

Stop processing whenever a target file exists, to prevent destroying
existing files by accident.  This should be mostly wanted when run
from some automatic mechanism, like L<crontab(1)|crontab/1>.  So,
this is the default if no terminal is found at C<STDIN>.

=item ask

Ask you what to do when a target file exists.  This should be most
wanted if you are running arclog.pl interactively.  So, this is the
default if a terminal is found at C<STDIN>.  The answers are read
from C<STDIN>.  Since you have only one C<STDIN>, you cannot specify
this mode if you want read the log file from C<STDIN>.  In that case,
it will fall back to the <samp>fail</samp> mode.  Also, if
F<arclog.pl> cannot get its answer from C<STDIN>, for ex., on a
closed C<STDIN> like L<crontab(1)|crontab/1>, it will fall back to
C<fail> mode.

=back

=item -k,--keep[=mode]

What to keep in the source file.  Currently the following modes are
supported:

=over

=item a,all

Keep the source file after records are archived.  If C<--keep> was
specified without C<mode>, it assumes that you want to keep all.

=item r,restart

Restart the source file after records are archived.

=item d,delete

Delete the source file after records are archived.

=item t,this-month

Archive and strip records of previous months off from the log file.
Keep the records of this month in the source log file, to be archived
next month.  This is designed to be run from L<crontab(1)|crontab/1>
monthly, so this is the default.

=back

=item -d, --debug

Show the detailed debugging messages.

=item -q, --quiet

Shihhhhhh.  Only yell when errors.

=item -h, --help

Display the help message and exit.

=item -v, --version

Output version information and exit.

=back

=head1 VERSION

2.1.0

=head1 COPYRIGHT

Copyright (c) 2001 imacat. All rights reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but I<WITHOUT ANY WARRANTY>; without even the implied warranty of
I<MERCHANTABILITY> or I<FITNESS FOR A PARTICULAR PURPOSE>.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

=head1 AUTHOR

imacat <imacat@mail.imacat.idv.tw>.  Please visit F<arclog.pl>'s
websites at http://arclog.sourceforge.net/ and
http://www.imacat.idv.tw/tech/arclog.pl.html .

=head1 BUGS

F<arclog.pl> has a mailing list at SourceForge:
arclog-users@lists.sourceforge.net.  It is for
F<arclog.pl>'s users to discuss and report problems.  Its web page is
at http://lists.sourceforge.net/lists/listinfo/arclog-users .
If you have any problem or question on F<arclog.pl>, please go to
this page, join the list, and send your questions on this list.
Thank you.

=head1 TODO

=over

=item Reading compressed log files from C<STDIN>

This is possible, but not implemented yet.

=item Multi-lingual support

Support multi-lingual, either with L<Text::Iconv(3)|Text::Iconv/3> or
perl 5.8.0's L<Encode(3)|Encode/3>.

=item Set the sort size limit dynamically

Set the sort size limit according to the actual system memory.  This
can be possible only if I can obtain the total amount of the actual
system memory. :p

=item Read from C<STDIN> in a more natural way

For example, C<cat access_log | arclog.pl /archive/access_log>.  This
needs a rather complix manuplation on C<STDIN>, since it's a little
hard to judge rather C<STDIN> is detached from terminal due to
automatic mechanism like L<crontab(1)|crontab/1>, or due to named
pipe.

=back

=head1 SEE ALSO

L<gzip(1)|gzip/1>, L<zlib(3)|zlib/3>,
L<Compress::Zlib(3)|Compress::Zlib/3>, L<bzip2(1)|syslog/1>,
L<Compress::Bzip2(3)|Compress::Bzip2/3>, L<syslog(2)|syslog/2>

=cut
